# Lab 2 - Software Performance 2023

This is Lab 2 of the **Software Performance** course at USI.

Go to [this Lab on iCorsi](https://www.icorsi.ch/course/view.php?id=16963).

## Submission Info

| Property   | Value    |
|------------|----------|
| First Name | Claudio  |
| Last Name  | Maggioni |

## Submission Checklist

Please complete this checklist (turn [ ] into [X]) before you submit:

- [x] I completed the above Submission Info
- [x] I built the project in IntelliJ (Build > Build Project)
- [x] I ran test/test.sh and verified that it runs (and fails)
- [x] I implemented the analysis in src/Analyzer.java, outputting:
  - [x] Number of classes (incl. interfaces and enums)
  - [x] Number of concrete non-native, non-abstract methods (methods with code)
  - [x] Total number of instructions (ignoring instructions with opcode -1)
  - [x] Total number of instructions by opcode (ignoring instructions with opcode -1)
  - [x] Total number of method invocation instructions (== call sites)
  - [x] Total number of conditional branch instructions (excluding GOTO, but including multi-way branches)
- [x] I wrote the source code myself and did not look at the source code of my classmates
- [x] I ran test/test.sh and verified that it runs and passes
- [x] I committed my changes (at least one commit, but possibly many)
- [x] I pushed my commits to GitHub
